module WakuwakuModule
  module PostStatus
    class << self
      include ActionView::Helpers
      include ActionView::Context
        
      def create_user
        Comment.create(userable: User.first, message: 'C', commentable: Post.first)
      end
      
      def list_status(str)
        case str
        when 'approved'    then { text: generate_status(str), klass: 'tag tag-green' }
        when 'repost'      then { text: generate_status(str), klass: 'tag tag-blue' }
        when 'newpost'     then { text: generate_status(str), klass: 'tag tag-blue' }
        when 'rejected'    then { text: generate_status(str), klass: 'tag tag-red' }
        when 'published'   then { text: generate_status(str), klass: 'tag tag-green' }
        when 'reviewing'   then { text: generate_status(str), klass: 'tag tag-yellow' }
        when 'draft'       then { text: generate_status(str), klass: 'tag tag-gray' }
        when 'need_review' then { text: generate_status(str), klass: 'tag tag-yellow' }
        when 'unvailable'  then { text: generate_status(str), klass: 'tag tag-gray' }
        when 'waiting'     then { text: generate_status(str), klass: 'tag tag-red' }
        end
      end
    
      def status_view_editor(post)
        status = post.status
        status = 'newpost'    if status == 'reviewing' && post.count_submit <= 1
        status = 'repost'     if status == 'reviewing' && post.count_submit > 1
        status = 'unvailable' if status.nil?
        generate_span_status(status)
      end
    
      def status_view_translator(status)
        status = 'waiting' if status.nil?
        generate_span_status(status)
      end
    
      def status_view_writer(post)
        status = post.status
        status = 'approved' if status == 'need_review'
        generate_span_status(status)
      end

      private
    
      def generate_span_status(status)
        text  = list_status(status).fetch(:text)
        klass = list_status(status).fetch(:klass)
    
        content_tag(:span, text, class: klass)
      end
    
      def generate_status(str)
        I18n.t(".post_status.status.#{str}")
      end
    end
  end  
end
